<?php 
  // ce script php,  inclure dans une page de squelette permet de
	// demander au visiteur une confirmation quand il demande l'adresse
	// email d'un auteur d'article ou d'un auteur de message de forum.
	// Cette confirmation permet de faire barrage aux progammes (spambots)
	// collectant les adresses emails utilisees par le spam.
	//
	// Ce script s'inspire d'un script ecrit par Noe Cuneo du site www.cuk.ch.
	// Il a ete adapte pour SPIP par Yves Grenier
	//
	
	// debut du formulaire
  echo("<h1 class=\"structure\">Recherche d'une adresse email</h1>");

  // preparer la liste des mots pour valider la requete
	$liste_mots = array("lundi","mardi","jeudi","arbre","fleur",
  										"blanc","jaune","rouge","parme","lilas");
	$taille_liste_mots = count($liste_mots);
				
	// choisir l'etape initiale
  if (!isset($_POST['adresse_etape'])) {
	  $adresse_etape=1;
	} else {
	  $adresse_etape=intval($_POST['adresse_etape']);
  }	

	// rechercher si l'adresse demandee est celle d'un auteur
	if (isset($_REQUEST['id_auteur']))
	{
	  $id_auteur = intval($_REQUEST['id_auteur']);
		//<BOUCLE_auteur1 (AUTEURS){id_auteur}>
		$request = "SELECT email,nom FROM spip_auteurs WHERE id_auteur=".$id_auteur;
		$result = spip_query($request);
	  $email_a_afficher = "";
		$nom_a_afficher   = "";
		$article_ou_forum  = " texte inconnu";
		while ($row=spip_fetch_array($result))
		{
  	  $email_a_afficher = $row['email']; // "#EMAIL";
		  $nom_a_afficher   = $row['nom'];   // "[((#NOM))]";
			if (strlen($nom_a_afficher) > 0) {
			  $nom_a_afficher = " (".$nom_a_afficher.")";
			}
  		$article_ou_forum = " article";
		}
		//</BOUCLE_auteur1>
	}
	// rechercher si l'adresse demandee est celle d'un visiteur du forum
	elseif (isset($_REQUEST['id_forum']))
	{
	  $id_forum         = intval($_REQUEST['id_forum']);
	  $email_a_afficher = "";
		$nom_a_afficher   = "";
		$article_ou_forum = " texte inconnu";
  	//<BOUCLE_forum1 (FORUMS){id_forum}>
		$request = "SELECT auteur,email_auteur FROM spip_forum WHERE id_forum=".$id_forum;
		$result = spip_query($request);
		while ($row=spip_fetch_array($result))
		{
  	  $email_a_afficher = $row['email_auteur']; // "#EMAIL";
		  $nom_a_afficher   = $row['auteur'];   // "[((#NOM))]";
			if (strlen($nom_a_afficher) > 0) {
			  $nom_a_afficher = " (".$nom_a_afficher.")";
			}
  		$article_ou_forum = " commentaire";  // ou bien " message de forum"
		}
    //</BOUCLE_forum1>
  }
	else
	{
	  $email_a_afficher = "";
		$nom_a_afficher   = "";
		$article_ou_forum  = "";
	}

	// etape initiale: expliquer la procedure
	if ($adresse_etape==1)
	{
		// Mozilla 1.4 saisit au moins un caractre dans le champ email:
 		// exiger au moins 3 caractres pour une adresse valide.
		if (strlen($email_a_afficher)>3)
		{
 		  echo("<p class=\"texte\">Vous avez demand&eacute; l'adresse email de l'auteur d'un" );
      echo($article_ou_forum.$nom_a_afficher.".</p>");
 			echo('<p class="texte">
 			  Afin de prot&eacute;ger les adresses e-mail
  		  contre le spam, nous vous demandons de 
        r&eacute;pondre &agrave; la question suivante pour que nous
	  	  puissions &ecirc;tre s&ucirc;r que vous n\'&ecirc;tes pas un robot.
  		  </p>');
		}
 		else
		{
 		  echo("<p class=\"texte\">Vous avez demand&eacute; l'adresse email de l'auteur d'un ");
      echo($article_ou_forum.$nom_a_afficher.".</p>");
  		echo("<p class=\"texte\">L'auteur n'a pas laiss&eacute; son adresse email.</p>");
			$no_mail=1;
		}
	
		// etape 1: donner le mot a recopier
		if (!isset($no_mail))
		{
 			$id_mot_choisi = rand(0,$taille_liste_mots - 1);
  		$mot_choisi    = $liste_mots[$id_mot_choisi];
	  	echo('<div class="spip_encadrer">
   	  			<p align="center">
      		  Recopiez ce mot en minuscules: ' .strtoupper($mot_choisi) .
  		      '</p>');
		  echo('<form name="form1" method="post" action="adresse.php3">
            <p align="center">');
		  echo('<input name="adresse_etape" type="hidden" id="adresse_etape" value="2">');
			if (isset($id_forum)) {
			  echo('<input name="id_forum" type="hidden" id="id_forum" value="'
	    			.$id_forum.
		    		'">');
			} elseif (isset($id_auteur)) {
		    echo('<input name="id_auteur" type="hidden" id="id_auteur" value="'
	    			.$id_auteur.
		    		'">');
			}
		  echo('<input name="id_mot_choisi" type="hidden" id="id_mot_choisi" value="'
	  		  	.$id_mot_choisi.
			  		'">');
		  echo('<input name="adresse_reponse" type="text" id="adresse_reponse"> &nbsp;');
		  echo('<input type="submit" name="Submit" value="Envoyer">');
		  echo('</p>
  				  </div>
            </form>');
		}
	}

  // adresse_etape = 2, le lecteur a rpondu  la question,
	// il faut maintenant vrifier la rponse
	elseif ($adresse_etape==2)
	{
	  $id_mot_choisi = intval($_POST['id_mot_choisi']);
		$adresse_reponse = htmlentities($_POST['adresse_reponse']);
    if ($adresse_reponse==$liste_mots[$id_mot_choisi])
    {
		  echo("<p class=\"texte\">Vous avez demand&eacute; l'adresse e-mail de l'auteur d'un ".$article_ou_forum.$nom_a_afficher.". Cette adresse est:</p>
					 <p style=\"margin-left:56\"><a href=\"mailto:".$email_a_afficher."\"><b>".$email_a_afficher."</b></a></p>");
			echo("<p class=\"detail\">(vous pouvez cliquer sur le lien ci-dessus)</p>");
			echo("<br><br><br><br><br>");
    }
		else
		{
      echo("<p>Erreur: mauvaise r&eacute;ponse.</p>");
  		echo("<br><br><br><br><br>");
			echo("<br><br><br><br>");
    }
	}
?>